<?php
/**********************************************************************************
* Subs-BoardNews.php                                                              *
***********************************************************************************
* for use with SMF: Simple Machines Forum                                         *
* =============================================================================== *
* Software Version:           BoardNews 1.0                                       *
* Software by:                Oskari Rauta/Jake Irons (http://www.roadrunner.cx)  *
* Copyright 2007 by:          RoadRunner.cx (http://www.roadrunner.cx)            *
* Updates at:                 http://www.simplemachines.org                       *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it.        *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* The latest version can always be found at http://www.simplemachines.org.        *
**********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

/*	This file contains function(s) needed by BoardNews MOD.

	function genboardnews()
		- is called to fill $context['boardnews'];
*/

function genboardnews()
{
global $context, $boards, $boardList, $cat_tree, $modSettings, $db_prefix, $sourcedir, $user_info;

if (!$modSettings['bnews_enabled'])
	return;

require_once($sourcedir . '/Subs-Boards.php');

$context['bnews'] = array();
$amountBoards = 0;

getBoardTree();

foreach ($cat_tree as $catid => $tree)
	foreach ($boardList[$catid] as $boardid)
		++$amountBoards;

$showlatestcount = $modSettings['bnews_max'];

$news = array();
for ($tmp = 0; $tmp < $showlatestcount+1; $tmp++)
	$news[] = array(
				'name' => '',
				'autid' => 0,
				'time' => 0,
				'boardid' => 0,
				'topicid' => 0,
				'id' => 0,
				'topic' => '',
				'message' => '',
				);

for ($tmp = 1; $tmp < $amountBoards+1; $tmp++)
	{
	if (isset($modSettings['bnews_id' . $tmp])) if ($modSettings['bnews_id' . $tmp])
		{
		$tmp2 = 0;
		$request = db_query("
			SELECT m.posterTime, m.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG,
			IFNULL(mem.realName, m.posterName) AS posterName, t.ID_BOARD, b.name AS bName,
			LEFT(m.body, 384) AS body, m.smileysEnabled
			FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
			WHERE m.ID_MSG >= " . max(0, $modSettings['maxMsgID'] - 20 * $showlatestcount) . "
			AND t.ID_BOARD = $tmp.0
			AND t.ID_TOPIC = m.ID_TOPIC
			AND t.ID_FIRST_MSG = m.ID_MSG
			AND b.ID_BOARD = t.ID_BOARD" . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? "
			AND b.ID_BOARD != $modSettings[recycle_board]" : '') . "
			AND $user_info[query_see_board]
			ORDER BY m.posterTime DESC
			LIMIT $showlatestcount", __FILE__, __LINE__);
//			ORDER BY m.ID_MSG DESC
	
		$posts = array();
		while ($row = mysql_fetch_assoc($request))
			{
			$storelocation = -1;
			for ($tmp3 = $showlatestcount; $tmp3 > $tmp2; $tmp3--)
				if ( $news[$tmp3]['time'] < $row['posterTime'] )
					$storelocation = $tmp3;

			if ($storelocation != -1 )
				{
				if ($storelocation < $showlatestcount )
					for ($tmp3 = $showlatestcount; $tmp3 < $storelocation; $tmp3--)
						$news[$tmp3+1] = $news[$tmp3];

				$news[$storelocation]['name']=$row['posterName'];
				$news[$storelocation]['autid']=$row['ID_MEMBER'];
				$news[$storelocation]['time']=$row['posterTime'];
				$news[$storelocation]['boardid']=$row['ID_BOARD'];
				$news[$storelocation]['topicid']=$row['ID_TOPIC'];
				$news[$storelocation]['id']=$row['ID_TOPIC'];
				$news[$storelocation]['topic']=$row['subject'];
				$news[$storelocation]['message']=$row['body'];
				
				$tmp2 = $storelocation; //Speed optimization
				}
			}
		}
	$replacetags = array("<hr>", "<hr/>", "<hr />", "<br>", "<br/>" ,"<br />", "&nbsp;", "&quot;", "&amp;", "&copy;", "&auml;", "&ouml;", "&aring;", "&Auml;", "&Ouml;", "&Aring;");
	$replacechars = array("-", "-", "-", " ", " ", " ", " ", "\"", "&", "(C)", "", "", "", "", "", "");
	$context['boardnews'] = array();
	foreach ($news as $bnews)
		if ($bnews['time'] > 0 )
			{
			if (strlen($bnews['topic']) > $modSettings['bnews_chars'])
				{
				$bnews['topic'] = substr($bnews['topic'], 0, $modSettings['bnews_chars'] - 2);
				$bnews['topic'] .= '..';
				}
			$bnews['message'] = censorText(
									strip_tags(
										str_replace($replacetags, $replacechars, $bnews['message'])));
			if (strlen($bnews['message']) > $modSettings['bnews_hover'])
				{
				$bnews['message'] = substr($bnews['message'], 0, $modSettings['bnews_hover'] - 2);
				$bnews['message'] .= '..';
				}
			$bnews['topic'] = censorText($bnews['topic']);
			$context['boardnews'][] = $bnews;
			}
	}
}

?>